/*
 * Serial IO
 * by Jonathan Diehl
 *
 */

int outputPin = 13;
int inputPin = 12;

// setup
void setup() {

  // set up pins
  pinMode(outputPin, OUTPUT);
  digitalWrite(outputPin, LOW);

  // set up serial port
  Serial.begin(9600);

}

// main loop
void loop() {

  // read input only when available
  if (Serial.available() > 0) {

    // read last input byte
    int inSerial;
    while (Serial.available() > 0) {
      inSerial = Serial.read();
    }
    
    // send LOW to output pin if input is '0', otherwise HIGH
    digitalWrite(outputPin, inSerial == 48 ? LOW : HIGH);
  }

  // propagate input to serial port
  int inPin = digitalRead(inputPin);
  Serial.println(inPin);

  // processing at ~25 Hz
  delay(40);
}
