require "serialport.so"

# connecter to an arduino via a serial port
class Arduino
  PORT = '/dev/tty.usbserial-A6004pRx'
  BAUD_RATE = 9600
  DATA_BITS = 8
  STOP_BITS = 1
  PARITY = 0

  def self.instance
    @arduino ||= Arduino.new
  end
  
  def self.status
    instance.status
  end
  
  def self.led(state = true)
    instance.led(state)
  end
  
  def initialize
    @con = SerialPort.new PORT, BAUD_RATE, DATA_BITS, STOP_BITS, PARITY
  end
  
  def status
    c = nil
    while !c or c <= 13
      c = @con.getc
    end
    c == 49
  end
  
  def led(state = true)
    @con.putc(state ? 49 : 48);
  end
  
  def close
    @con.close
  end
  
end
